#include "KeyLockComposer.h"


int CKeyLockComposer::Process(CTileArranger *pTileArranger)
{
	m_pTileArranger = pTileArranger;
	m_locks.clear();
	m_keys.clear();
	ConstructGraph(&m_tiledGraph);

	for (int i = 0; i < (int) (m_pTileArranger->m_artiPoints.size()); ++i)
	{
		if (m_pTileArranger->m_artiPoints[i].type == ArtiPoint::Lock)
		{
			//  type  lock ̸ ̰  ġѴ.

			// ϴ  x, y ǥ ã´.
			int x,y;
			bool rbool = m_pTileArranger->FindCoorWithSequenceOnMainPath(m_pTileArranger->m_artiPoints[i].sequence, &x, &y);

			if (!rbool)
				return LEVGEN_NO_SLOT_WITH_SEQUENCE;

			bool flag = false;
			Direction::Type lockdir = Direction::End;
			for (int k = 0; k < NDIRECTION; k++) 
			{
				Direction::Type dir = DIRECTIONS[k];
				if (m_pTileArranger->m_slotMatrix[y][x].adjacencies[dir])
				{
					int nextX = x+DELTAX[dir];
					int nextY = y+DELTAY[dir];
					if (m_pTileArranger->IsValidCoor(nextX, nextY))
					{
						if ( m_pTileArranger->m_slotMatrix[nextY][nextX].pathType == Path::MainPath 
							&& m_pTileArranger->m_slotMatrix[nextY][nextX].sequence == (m_pTileArranger->m_artiPoints[i].sequence - 1))
						{
							flag = true;
							lockdir = dir;
							break;
						}
					}
				}
			}

			if (!flag)
				return LEVGEN_NO_SLOT_WITH_SEQUENCE;

			Lock newLock;
			newLock.x = x;
			newLock.y = y;
			newLock.dir = lockdir;
			newLock.complexity = m_pTileArranger->m_userCondition.lockDefs[m_pTileArranger->m_artiPoints[i].index].complexity;
			newLock.numOfKeys = m_pTileArranger->m_userCondition.lockDefs[m_pTileArranger->m_artiPoints[i].index].numOfKey;

			int lastArtiSequence;
			if (i == 0)
			{
				lastArtiSequence = 1;
			}
			else
			{
				lastArtiSequence = m_pTileArranger->m_artiPoints[i-1].sequence;
			}

			int sectionStartX,sectionStartY;
			rbool = m_pTileArranger->FindCoorWithSequenceOnMainPath(lastArtiSequence, &sectionStartX, &sectionStartY);
			if (!rbool)
				return LEVGEN_NO_SLOT_WITH_SEQUENCE;

			int rtv = SubsequentProcessToLock(m_pTileArranger->m_userCondition.lockDefs[m_pTileArranger->m_artiPoints[i].index],
											m_tiledGraph, newLock, sectionStartX,sectionStartY);

			if (rtv != LEVGEN_NOERROR)
				return rtv;
		}

		// arti point ̿Ͽ  ´.
		//  section lock شϴ lock̳ key  section ȿ ϵ
		int x,y;
		int apSequence = m_pTileArranger->m_artiPoints[i].sequence;
		bool rbool = m_pTileArranger->FindCoorWithSequenceOnMainPath(apSequence, &x, &y);
		if (!rbool)
			return LEVGEN_NO_SLOT_WITH_SEQUENCE;

		for (int k = 0; k < NDIRECTION; k++) 
		{
			Direction::Type dir = DIRECTIONS[k];
			if (m_pTileArranger->m_slotMatrix[y][x].adjacencies[dir])
			{
				int nextX = x+DELTAX[dir];
				int nextY = y+DELTAY[dir];
				if ( m_pTileArranger->m_slotMatrix[nextY][nextX].pathType == Path::MainPath 
					&& m_pTileArranger->m_slotMatrix[nextY][nextX].sequence == (apSequence - 1))
				{
					if (m_tiledGraph.adjacency[y][x][dir] == EdgeInTiledGraph::Disconnected)
						return LEVGEN_INVALID_GRAPH_CONNECTION;

					if (m_tiledGraph.adjacency[nextY][nextX][(Direction::Type) (3 - dir)]  == EdgeInTiledGraph::Disconnected)
						return LEVGEN_INVALID_GRAPH_CONNECTION;

					m_tiledGraph.adjacency[y][x][dir] =  EdgeInTiledGraph::Locked;
					m_tiledGraph.adjacency[nextY][nextX][(Direction::Type) (3 - dir)] = EdgeInTiledGraph::Locked;
				}
			}
		}

	}

	return LEVGEN_NOERROR;
}

void CKeyLockComposer::ConstructGraph(TiledGraph *tiledGraph)
{
	memset((void*) tiledGraph, 0, sizeof(TiledGraph));
	tiledGraph->height = m_pTileArranger->m_userCondition.height;
	tiledGraph->width = m_pTileArranger->m_userCondition.width;

	for (int i = 0; i < tiledGraph->height; i++)
	{
		for (int j = 0; j < tiledGraph->width; j++)
		{
			for (int k = 0; k < NDIRECTION; k++)
			{
				if (m_pTileArranger->m_slotMatrix[i][j].adjacencies[k])
				{
					tiledGraph->adjacency[i][j][k] = EdgeInTiledGraph::Connected;
				}
				else
				{
					tiledGraph->adjacency[i][j][k] = EdgeInTiledGraph::Disconnected;
				}
			}
		}
	}
}

int CKeyLockComposer::GetCutGraph(TiledGraph &tileGraph, Lock &lock, TiledGraph *newGraph)
{
	memcpy((void*) newGraph, (void*) &tileGraph, sizeof(TiledGraph));

	int nextx = lock.x + DELTAX[lock.dir];
	int nexty = lock.y + DELTAY[lock.dir];
	Direction::Type nextdir = (Direction::Type) (3 - lock.dir);


	if (newGraph->adjacency[lock.y][lock.x][lock.dir] != EdgeInTiledGraph::Connected)
		return LEVGEN_INVALID_GRAPH_CONNECTION;
	if (newGraph->adjacency[nexty][nextx][nextdir] != EdgeInTiledGraph::Connected)
		return LEVGEN_INVALID_GRAPH_CONNECTION;

	newGraph->adjacency[lock.y][lock.x][lock.dir] = EdgeInTiledGraph::Locked;
	newGraph->adjacency[nexty][nextx][nextdir] = EdgeInTiledGraph::Locked;

	return LEVGEN_NOERROR;
}

int CKeyLockComposer::AllocateLock(LockDef lockdef, int rootX, int rootY, TiledGraph &g, Lock *newLock)
{
	vector<Bridge> bridges;
	
	FindBridges(g, rootX, rootY, &bridges);

	if (bridges.size() == 0)
		return LEVGEN_NO_BRIDGE_TO_ALLOC_LOCK;

	// ߰ Bridge߿ ϰ ϳ Ͽ Lock ġ
	int randsel = rand() % ((int) (bridges.size()));

	newLock->x = bridges[randsel].x;
	newLock->y = bridges[randsel].y;
	newLock->dir = bridges[randsel].dir;
	newLock->numOfKeys = lockdef.numOfKey;
	newLock->complexity = lockdef.complexity;

	int rtv = SubsequentProcessToLock(lockdef, g, *newLock, rootX, rootY);
	if (rtv != LEVGEN_NOERROR)
		return rtv;

	return LEVGEN_NOERROR;
}



void CKeyLockComposer::FindBridges(TiledGraph &g, int rootX, int rootY, vector<Bridge> *bridges)
{
	bridges->clear();
	memset((void*) m_dForDfs, 0, sizeof(m_dForDfs));
	memset((void*) m_lowForDfs, 0, sizeof(m_lowForDfs));

	m_counterForDfs = 0;
	m_artiPoints.clear();
	ADFS(g, rootX, rootY, -1, -1, true);

	for (int i = 0; i < (int) (m_artiPoints.size()); i++)
	{
		Coor artiPoint = m_artiPoints[i];

		for (int k = 0; k < NDIRECTION; k++)
		{
			Direction::Type dir = DIRECTIONS[k];

			if (g.adjacency[artiPoint.y][artiPoint.x][dir] != EdgeInTiledGraph::Connected) continue;

			int nextX = artiPoint.x + DELTAX[dir];
			int nextY = artiPoint.y + DELTAY[dir];

			bool isConsidered = false;
			for (int j = 0; j < i; j++)
			{
				if (m_artiPoints[j].x == nextX && m_artiPoints[j].y == nextY)
				{
					isConsidered = true;
					break;
				}
			}
			if (isConsidered) continue;

			int d1 = m_dForDfs[artiPoint.y][artiPoint.x];
			int d2 = m_dForDfs[nextY][nextX];
			int low1 = m_lowForDfs[artiPoint.y][artiPoint.x];
			int low2 = m_lowForDfs[nextY][nextX];


			if (d1 > d2)
			{
				swap(d1, d2);
				swap(low1, low2);
			}

			if (d1 < low2)
			{	// bridge ߰
				//   bridge  vertex   mainpath  ִٸ Ѵ.
				if ((m_pTileArranger->m_slotMatrix[artiPoint.y][artiPoint.x].pathType != Path::MainPath
						&& m_pTileArranger->m_slotMatrix[artiPoint.y][artiPoint.x].pathType != Path::ExtendedMP)
					|| (m_pTileArranger->m_slotMatrix[nextY][nextX].pathType != Path::MainPath
						&& m_pTileArranger->m_slotMatrix[nextY][nextX].pathType != Path::ExtendedMP))
				{
					Bridge newbridge;
					if (m_dForDfs[artiPoint.y][artiPoint.x] < m_dForDfs[nextY][nextX])
					{
						newbridge.x = nextX;
						newbridge.y = nextY;
						newbridge.dir = (Direction::Type) (3 - dir);
					}
					else
					{
						newbridge.x = artiPoint.x;
						newbridge.y = artiPoint.y;
						newbridge.dir = dir;
					}

					bridges->push_back(newbridge);
				}
			}
		}
	}
}

int CKeyLockComposer::ADFS(TiledGraph &g, int x, int y, int parentX, int parentY, bool isRoot)
{
	int childCount = 0;
	bool isArti = false;
	m_dForDfs[y][x] = (++m_counterForDfs);
	m_lowForDfs[y][x] = m_dForDfs[y][x];

	for (int k = 0; k < NDIRECTION; k++) 
	{
		Direction::Type dir = DIRECTIONS[k];
		if (g.adjacency[y][x][dir] == EdgeInTiledGraph::Locked) 
		{	// subtree lock ִ 쿡   lock   츦   
			//  vertex    ȴ.
			m_lowForDfs[y][x] = 0;
			continue;
		}
		if (g.adjacency[y][x][dir] != EdgeInTiledGraph::Connected) continue;

		int nextX = x + DELTAX[dir];
		int nextY = y + DELTAY[dir];

		// parent node  low     ʾƾ 
		if (nextX == parentX && nextY == parentY) continue; 

		int rtv = 0;
		if (m_dForDfs[nextY][nextX] == 0)
		{
			childCount++;
			rtv = ADFS(g, nextX, nextY, x, y, false);
			
			if (rtv >= m_dForDfs[y][x])
			{	// ̴.
				isArti = true;
			}
		}
		else
		{
			rtv = m_lowForDfs[nextY][nextX];
		}

		if (rtv < m_lowForDfs[y][x])
		{
			m_lowForDfs[y][x] = rtv;
		}
	}

	if ((!isRoot && isArti)
		|| (isRoot && childCount > 1))
	{
		// ̴.
		Coor newCoor;
		newCoor.x = x;
		newCoor.y = y;
		m_artiPoints.push_back(newCoor);
	}

	return m_lowForDfs[y][x];
}


int CKeyLockComposer::SubsequentProcessToLock(LockDef lockdef, TiledGraph &tileGraph, Lock newLock, int sectionStartX, int sectionStartY)
{
	if (lockdef.complexity > 0)
	{
		//   Lock( L1) ø Ѿ  
		// ο Lock( L2) ϰ
		// L1 Key L2 ο ġѴ.

		LockDef newLockDef;
		newLockDef.numOfKey = 1;
		newLockDef.complexity = lockdef.complexity - 1;

		TiledGraph newGraph;
		//  ġ Lock  ׷ ڸ.
		int rtv = GetCutGraph(tileGraph, newLock, &newGraph);
		if (rtv != LEVGEN_NOERROR)
			return rtv;

		int rootX = newLock.x+DELTAX[newLock.dir];
		int rootY = newLock.y+DELTAY[newLock.dir];

		Lock	subordinateLock;
		rtv = AllocateLock(newLockDef, sectionStartX, sectionStartY, newGraph, &subordinateLock);
		if (rtv != LEVGEN_NOERROR) 
			return rtv;
		

		TiledGraph newGraphCutSubordinateLock;

		rtv = GetCutGraph(newGraph, subordinateLock, &newGraphCutSubordinateLock);
		if (rtv != LEVGEN_NOERROR)
			return rtv;

		int rootX1 = subordinateLock.x;
		int rootY1 = subordinateLock.y;

		m_locks.push_back(newLock);

		// key ġ κ
		for (int i = 0; i < newLock.numOfKeys; i++)
		{
			Key		newkey;

			// key ϳ ø lock ο ְϸ ȴ.
			//  ø lock ο ִ ۿ ִ  .
			if (i == 0)
			{
				rtv = AllocateKey(rootX1, rootY1, newGraphCutSubordinateLock, &newkey);
			}
			else
			{
				rtv = AllocateKey(rootX, rootY, newGraph, &newkey);
			}

			if (rtv != LEVGEN_NOERROR) 
				return rtv;

			newkey.relLockIndex = (int) (m_locks.size() - 1);

			m_keys.push_back(newkey);

			m_locks[(int) m_locks.size() - 1].relKeyIndexes.push_back((int) (m_keys.size()-1));
		}
	}
	else
	{
		TiledGraph newGraph;
		int rtv = GetCutGraph(tileGraph, newLock, &newGraph);
		if (rtv != LEVGEN_NOERROR)
			return rtv;

		int rootX = newLock.x+DELTAX[newLock.dir];
		int rootY = newLock.y+DELTAY[newLock.dir];

		m_locks.push_back(newLock);

		// key ġ κ
		for (int i = 0; i < newLock.numOfKeys; i++)
		{
			Key		newkey;
			rtv = AllocateKey(rootX, rootY, newGraph, &newkey);
			if (rtv != LEVGEN_NOERROR) 
				return rtv;

			newkey.relLockIndex = (int) (m_locks.size() - 1);

			m_keys.push_back(newkey);

			m_locks[(int) m_locks.size() - 1].relKeyIndexes.push_back((int) (m_keys.size()-1));
		}
	}

	return LEVGEN_NOERROR;
}


int	CKeyLockComposer::AllocateKey(int rootX, int rootY, TiledGraph &g, Key *newKey)
{
	Coor startCoor;
	startCoor.x = rootX;
	startCoor.y = rootY;

	// ʺ 켱 Ž  Key ġ  Slot List .
	deque<Coor> queOfCoor;
	vector<Coor> candidateSlotsMain;
	vector<Coor> candidateSlotsSub;
	queOfCoor.clear();
	candidateSlotsMain.clear();
	candidateSlotsSub.clear();

	memset((void*) m_bVisitedBfs, 0, sizeof(m_bVisitedBfs));
	m_bVisitedBfs[rootY][rootX] = true;

	queOfCoor.push_back(startCoor);
	while(!queOfCoor.empty())
	{
		Coor curCoor = queOfCoor.front();
		queOfCoor.pop_front();

		if (m_pTileArranger->m_slotMatrix[curCoor.y][curCoor.x].isUsed == false)
		{
			if (m_pTileArranger->m_slotMatrix[curCoor.y][curCoor.x].pathType == Path::MainPath
				|| m_pTileArranger->m_slotMatrix[curCoor.y][curCoor.x].pathType == Path::ExtendedMP)
			{
				candidateSlotsMain.push_back(curCoor);
			}
			else
			{
				candidateSlotsSub.push_back(curCoor);
			}
		}

		for (int k = 0; k < NDIRECTION; k++) 
		{
			Direction::Type dir = DIRECTIONS[k];

			if (g.adjacency[curCoor.y][curCoor.x][dir] != EdgeInTiledGraph::Connected) continue;

			Coor newCoor;
			newCoor.x = curCoor.x + DELTAX[dir];
			newCoor.y = curCoor.y + DELTAY[dir];

			if (m_bVisitedBfs[newCoor.y][newCoor.x]) continue;

			queOfCoor.push_back(newCoor);
			m_bVisitedBfs[newCoor.y][newCoor.x] = true;
		}
	}

	if (candidateSlotsSub.size() == 0 && candidateSlotsMain.size() == 0)
	{
		return LEVGEN_NO_SLOT_TO_ALLOC_KEY;
	}

	// Key ġ  Slot ϰ ϳ ؼ Key ġѴ.
	//   Sub Path  ϰ,  Main Path  ġ.
	if (candidateSlotsSub.size() != 0)
	{
		int randsel = rand() % ((int) (candidateSlotsSub.size()));

		newKey->x = candidateSlotsSub[randsel].x;
		newKey->y = candidateSlotsSub[randsel].y;
	}
	else
	{
		int randsel = rand() % ((int) (candidateSlotsMain.size()));

		newKey->x = candidateSlotsMain[randsel].x;
		newKey->y = candidateSlotsMain[randsel].y;
	}

	m_pTileArranger->m_slotMatrix[newKey->y][newKey->x].isUsed = true;

	return LEVGEN_NOERROR;

}

void CKeyLockComposer::PrintMatrix(ostream& os)
{
	for (int i = 0; i < m_pTileArranger->m_userCondition.height; i++) 
	{
		for (int j = 0; j < m_pTileArranger->m_userCondition.width; j++) 
		{
			bool flag = false;
			for (int k = 0; k < (int) m_keys.size(); k++)
			{
				if (m_keys[k].y == i && m_keys[k].x == j)
				{
					for (int o = 0; o < (int) m_locks[m_keys[k].relLockIndex].relKeyIndexes.size(); o++)
					{
						if (k == m_locks[m_keys[k].relLockIndex].relKeyIndexes[o])
						{
							flag = true;
							os << "K" << (char) (97 + m_keys[k].relLockIndex) << o;
							break;
						}
					}
					if (flag) break;
				}
			}
			if (!flag)
				os << m_pTileArranger->m_slotMatrix[i][j].sequence;
			
			if (j != m_pTileArranger->m_userCondition.width-1)
			{
				bool flag = false;
				for (int k = 0; k < (int) m_locks.size(); k++)
				{
					if ( (m_locks[k].dir == Direction::East && m_locks[k].y == i  && m_locks[k].x == j)
						|| (m_locks[k].dir == Direction::West && m_locks[k].y == i  && m_locks[k].x == j + 1) )
					{
						flag = true;
						os << (char) (97 + k);
						break;
					}
				}

				if (!flag)
				{
					if (m_pTileArranger->m_slotMatrix[i][j].adjacencies[Direction::East] == true)
						os << "-";
					else
						os << " ";
				}
			}
			os << "\t";
		}
		os << endl;
		for (int j = 0; j < m_pTileArranger->m_userCondition.width; j++) 
		{
			bool flag = false;
			for (int k = 0; k < (int) m_locks.size(); k++)
			{
				if ( (m_locks[k].dir == Direction::South && m_locks[k].y == i  && m_locks[k].x == j)
					|| (m_locks[k].dir == Direction::North && m_locks[k].y == i+1  && m_locks[k].x == j) )
				{
					flag = true;
					os << (char) (97 + k);
					break;
				}
			}

			if (!flag)
			{
				if (m_pTileArranger->m_slotMatrix[i][j].adjacencies[Direction::South])
					os << "|";
				else
					os << " ";
			}
			os << " " << "\t";

		}
		os << endl;
	}

	for (int i = 0; i < m_pTileArranger->m_userCondition.height; i++) 
	{
		for (int j = 0; j < m_pTileArranger->m_userCondition.width; j++) 
		{
			if (m_pTileArranger->m_slotMatrix[i][j].tileindex == -1) 
				os << "-1 ";
			else
				os << m_pTileArranger->m_pTileContainer->m_tiles[m_pTileArranger->m_slotMatrix[i][j].tileindex].id << " ";
		}
		os << endl;
	}
}
