#pragma once

#include "..\common\common.h"
#include "UserCondition.h"
#include "..\common\TileContainer.h"

//////////////////////////////////////////////////////////////////////////////////////////////////
/// \brief Slot ϴ ׷ ϰ,    Ÿ ġѴ.
///
/// slot Ÿ ϳ ġǴ ̰, ü level  slot matrix ̴.
///   slot vertex ϰ  slot edge Ͽ graph Ѵ.
///   graph  vertex  Ÿ ġѴ.
/// 
//////////////////////////////////////////////////////////////////////////////////////////////////
class CTileArranger
{
	friend class CKeyLockComposer;
	friend class CCelledMapGenerator;
public:
	/** 
	* \brief ־ User Condtion  Tile set  ̿Ͽ ׷ ϰ Ÿ ġѴ.
	* 
	*   CTileArranger member Լ  ȣν  Ѵ.
	* 
	* \param	t_userCondition	ڰ Է  
	* \param	pTileContainer	CTileContainer pointer
	* \return	 ڵ
	*/
	int		Process(UserCondition t_userCondition, CTileContainer* pTileContainer);
	void	ResetMatrix();
	void	PrintMatrix(ostream& os);

private:
	/** 
	* \brief ڷ ־ ϼ ̸ ϴ Main Path Ѵ.
	* 
	* Dfs() ȣϿ Ʈŷ Path Ѵ.
	* 
	* \param	reqTurn	ڰ 䱸 ϼ
	* \param	reqLen	ڰ 䱸 
	* \return	 ڵ
	*/
	int		GenMainPath(int reqTurn, int reqLen);

	/** 
	* \brief ڰ û Lock Sokoban Main Path    ġѴ.
	* 
	*   Lock Sokoban ġ Slot Graph 󿡼 Articulation Point ȴ.
	*  Mission Clearϱ ؼ ݵ  Slot  Ѵ.
	* 
	* \param	lastSequence	 main path 
	* \return	 ڵ
	*/
	int		SetArtiPoints(int lastSequence);

	/** 
	* \brief ġ Ariculation Point  Section .
	*/
	void	SetSection();

	/** 
	* \brief Section  ڰ    Main path β .
	* 
	* \param	lastSequence	 main path 
	* \return	 ڵ
	*/
	int		BroadenMainPath(int lastSequence);

	/** 
	* \brief Section  ڰ    sub path Ѵ.
	*
	* sub path main path ̹  sub path   ̴.
	* cycle    ٸ section main path Ǵ   ʴ´.
	*  MakeSubPath()  ȣѴ.
	* 
	* \param	lastSequence	 main path 
	* \return	 ڵ
	*/
	int		ComplicateMap(int lastSequence);

	/** 
	* \brief ڷ  Slotκ ̿ Slotϳ ϰ Ѵ.
	*
	*  Ͽ   sub path Ѵ.
	* 
	* \param	x	Ȯ Slot xǥ
	* \param	y	Ȯ Slot yǥ
	* \param	curDir	ֱ Ȯ 
	* \param	maxLen	sub path  
	* \param	orgSeq	current sub path ٿ Ǵ main path sequence. 2*2 cycle Ͽ  о   
	* \param	bCycleAllowed	ٽ main path Ǵ cycle ϴ  . ̰ ϴ  ø Lock
								ġϱ ؼ ġ ø Lock   "cycle ƴ sub path" ʿϱ ̴.
	* \return	 ڵ
	*/
	void	MakeSubPath(int x, int y, Direction::Type curDir, int maxLen, int orgSeq, bool bCycleAllowed);

	/** 
	* \brief Solution Graph   Slot ϰ Ѵ.
	*
	*   Solution Graph Slot  ʵ Ѵ.
	*
	* \return	 ڵ
	*/
	int		RandomlyConnectMargin();

	/** 
	* \brief  Slot  Ÿ ġѴ.
	*
	* Ÿ ġ ù°   Ÿ  Ἲ̴.
	* ̸  Graph  Slot ̿ Slot  Ǿ ִ  ľϿ ̿ ´ Ÿ ġѴ.
	*
	* ι°  ̹ Ÿ ġ  Slot  Ἲ̴.
	* 
	* \return	 ڵ
	*/
	int		ArrangeTile();

	/** 
	* \brief Ʈŷ Ͽ Main Path Ѵ.
	*
	* \param	curX	xǥ
	* \param	curY	yǥ
	* \param	curDir	ֱ Ȯ 
	* \param	curTurn	ݱ  
	* \param	curLen	ݱ 
	* \param	reqTurn	䱸  
	* \param	reqLen	䱸 
	* \return	 ڵ
	*/
	int		Dfs(int curX, int curY, Direction::Type curDir, 
							int curTurn, int curLen, 
							int reqTurn, int reqLen);

	bool	IsValidCoor(int curX, int curY);
	bool	FindCoorWithSequenceOnMainPath(int sequence, int *x, int *y);

	/** 
	* \brief  Ÿ  ǥ Slot ġ   Slot  յ ġ ȯѴ.
	*
	* \param	x	Ÿ ġ Slot xǥ
	* \param	y	Ÿ ġ Slot yǥ
	* \param	tileIndex	ġ Ÿ id
	* \return	 յ
	*/
	float	EvalAdjRel(int x, int y, int tileIndex);
	void	GetEdgeCoor(Direction::Type dir, int index, int *x, int *y);

private:
	/** 
	* \brief Slot ̷ Matrix. ü level Ÿ.
	*/
	Slot				m_slotMatrix[MAX_SLOT_MATRIX_SIZE][MAX_SLOT_MATRIX_SIZE];

	/** 
	* \brief ڰ Է  
	*/
	UserCondition		m_userCondition;

	/** 
	* \brief Articulation Points(Lock or Sokoban) 
	*/
	vector<ArtiPoint>	m_artiPoints;
	int					m_startX;
	int					m_startY;
	int					m_endX;
	int					m_endY;

	/** 
	* \brief  Ÿ 
	*/
	CTileContainer*		m_pTileContainer;
};

