#pragma once

#include "..\common\common.h"

const int MAX_ARTICULATION_POINT_NUM = 50;

const TCHAR * const LEVGEN_USERCOND_TAG_USERCONDITION		= _T("UserCondition");
const TCHAR * const LEVGEN_USERCOND_TAG_TILESETXML			= _T("TileSetXML");
const TCHAR * const LEVGEN_USERCOND_TAG_UNITXML				= _T("UnitXML");
const TCHAR * const LEVGEN_USERCOND_TAG_MAPSIZE				= _T("MapSize");
const TCHAR * const LEVGEN_USERCOND_TAG_MAINPATH			= _T("MainPath");
const TCHAR * const LEVGEN_USERCOND_TAG_LOCKDEF				= _T("LockDefinition");
const TCHAR * const LEVGEN_USERCOND_TAG_LOCK				= _T("Lock");
const TCHAR * const LEVGEN_USERCOND_TAG_SOKOBANDEF			= _T("SokobanDefinition");
const TCHAR * const LEVGEN_USERCOND_TAG_SOKOBAN				= _T("Sokoban");
const TCHAR * const LEVGEN_USERCOND_TAG_SECTION				= _T("Section");
const TCHAR * const LEVGEN_USERCOND_TAG_SUBPATH				= _T("SubPath");

const TCHAR * const LEVGEN_USERCOND_ATTR_PATH				= _T("path");
const TCHAR * const LEVGEN_USERCOND_ATTR_WIDTH				= _T("width");
const TCHAR * const LEVGEN_USERCOND_ATTR_HEIGHT				= _T("height");
const TCHAR * const LEVGEN_USERCOND_ATTR_TURN				= _T("turn");
const TCHAR * const LEVGEN_USERCOND_ATTR_LENGTH				= _T("length");
const TCHAR * const LEVGEN_USERCOND_ATTR_NUMOFKEY			= _T("numOfKey");
const TCHAR * const LEVGEN_USERCOND_ATTR_COMPLEXITY			= _T("complexity");
const TCHAR * const LEVGEN_USERCOND_ATTR_DIFFICULTY			= _T("difficulty");
const TCHAR * const LEVGEN_USERCOND_ATTR_THICKNESS			= _T("thinkness");

struct LockDef
{
	int		numOfKey;
	int		complexity;
};

struct SokobanDef
{
	int		difficulty;
};


struct UserCondition
{
	int					height;
	int					width;
	int					turnOnMainPath;
	int					lenOfMainPath;
	int					nOfLock;
	vector<LockDef>		lockDefs;
	int					nOfSokoban;
	vector<SokobanDef>	sokobanDefs;
	//int					sokobanDiffs[MAX_ARTICULATION_POINT_NUM];		//  sokoban puzzle  ̵
	int					sectionDiffs[MAX_ARTICULATION_POINT_NUM];		// section  ̵
	int					sectionThickness[MAX_ARTICULATION_POINT_NUM];	// section  main path  β
	string				tilesetXMLPath;
	string				unitXMLPath;
};

extern int ReadUserConditionXML(string fullpath, UserCondition *userCond);