#pragma once
#include "stdafx.h"
#include "..\common\common.h"

struct CellLock
{
	int				x1;
	int				y1;
	int				x2;
	int				y2;
	Direction::Type dir;
	int				numOfKeys;
	vector<int>		relKeyIndexes;
};

struct Key
{
	int			x;
	int			y;
	int			relLockIndex;
};

struct Block
{
	int			x;
	int			y;
	int			OnOff;			// 1̸ On 0̸ Off
};

struct Action
{
	int			x;
	int			y;
	int			exp;
	int			relIndex;	//  Lock or etc
	
	// Unlock ׼϶  ׼Ǹ ǮԵ Lock .
	vector<CellLock>	UnLockingLocks;		

	// Solve Sokoban  ѹ濡 ǮԵ sokoban block  
	vector<Block>		SolvingBlocks;

	enum Type
	{
		None	= 0,
		Move,
		GetKey,
		UnLock,
		SolveSokoban,
		KillMonster
		
	};
	Type		type;
};

struct Monster
{
	int			x;
	int			y;
	int			level;
	int			exp;
};

struct Result
{
	int					width;
	int					height;
	string				idmatrix[MAX_SLOT_MATRIX_SIZE][MAX_SLOT_MATRIX_SIZE];
	string				tilesetXmlPath;
	vector<CellLock>	locks;
	vector<Key>			keys;
	
	vector<Block>		blocks;


	vector<Action>		m_cellSolutionPath;

	vector<Monster>		monsters;


	int					startx;
	int					starty;

	int					endx;
	int					endy;

};
