#include "stdafx.h"
#include "Result.h"
#include "ResultParser.h"
#include "..\common\LevelGenResult.h"
#include "..\common\tinyxml.h"
#include "..\common\Unit.h"

//////////////////////////////////////////////////////////////////////////////////////////////////
/// Renderer  Է¿ Ǵ XML о  ParseResult Լ κ
/// XML о TiXmlElement   Ʈ شϴ  ãƳ. 
/// ǿ  Lock 쿡 Ǵ Key   ̾, 
/// SolutionPath Action   Ǵ  ߰ оδ. 
/// 
//////////////////////////////////////////////////////////////////////////////////////////////////
int ParseResult(string fullpath, Result *result)
{
	//XML full path Է¹޴´. 
	TiXmlDocument resultXml(fullpath.c_str());
	if (!(resultXml.LoadFile())) 
		return LEVGEN_FILEOPENERROR;
	
	//"level definition"Ű带 ã´. 
	TiXmlNode* root = resultXml.FirstChild(LEVGEN_RESULT_LEVEL_DEFINITION);
	if (!root) 
		return LEVGEN_INVALIDTILESET;

	TiXmlElement* tileallocElem = root->FirstChildElement(LEVGEN_RESULT_TILEALLOCATION);
	if (!tileallocElem) 
		return LEVGEN_INVALIDTILESET;
	
	// width height д´. 
	result->width = atoi(tileallocElem->Attribute(LEVGEN_RESULT_ATTR_WIDTH));
	result->height = atoi(tileallocElem->Attribute(LEVGEN_RESULT_ATTR_HEIGHT));
	result->tilesetXmlPath = tileallocElem->Attribute(LEVGEN_RESULT_ATTR_TILESETPATH);

	TiXmlNode* idmatrixRow = tileallocElem->FirstChild();
	
	
	// Tile id matrix д´. 
	for(int i = 0; i< result->height; i++) 
	{
		string	row = idmatrixRow->Value();
		int		lastpos = 0;
		int		count = 0;
		for (int j = 0; j < (int) (row.size()); j++) 
		{
			if (row[j] == ' ')
			{
				if (j - lastpos > 0)
				{
					result->idmatrix[i][count++] = row.substr(lastpos, j - lastpos);
					if (count >= result->width) break;
				}
				lastpos = j + 1;
			}
		}
		idmatrixRow = idmatrixRow->NextSibling();
	}

	TiXmlElement* leveldefElem = root->FirstChildElement(LEVGEN_RESULT_LOCKKEYALLOCATION);
	if (!leveldefElem) 
		return LEVGEN_INVALIDTILESET;
	
	//Lock  Ǵ Key  а Ѵ. 
	TiXmlElement* lockElem = leveldefElem->FirstChildElement(LEVGEN_RESULT_LOCK);
	while(lockElem)
	{
		CellLock newlock;

		bool flag = false;
		for (int i = 0; i < NDIRECTION; i++)
		{	
			// Lock ǥ ܿ ⿡     Ƿ Ǵ Ⱚ ã´. 
			if (strcmp(lockElem->Attribute(LEVGEN_RESULT_ATTR_DIRECTION), STRDIRECTION[i]) == 0)
			{
				newlock.dir = (Direction::Type) i;
				flag = true;
				break;
			}
		}
		assert(flag);

		newlock.x1 = atoi(lockElem->Attribute(LEVGEN_RESULT_ATTR_X1));
		newlock.x2 = atoi(lockElem->Attribute(LEVGEN_RESULT_ATTR_X2));
		newlock.y1 = atoi(lockElem->Attribute(LEVGEN_RESULT_ATTR_Y1));
		newlock.y2 = atoi(lockElem->Attribute(LEVGEN_RESULT_ATTR_Y2));

		result->locks.push_back(newlock);

		TiXmlElement* keyElem = lockElem->FirstChildElement(LEVGEN_RESULT_KEY);
		
		//Lock Ǵ Key д´. 
		while(keyElem)
		{
			Key key;
			key.x = atoi(keyElem->Attribute(LEVGEN_RESULT_ATTR_X));
			key.y = atoi(keyElem->Attribute(LEVGEN_RESULT_ATTR_Y));
			key.relLockIndex = (result->locks.size()) - 1;

			result->keys.push_back(key);

			result->locks[(int) (result->locks.size()) - 1].relKeyIndexes.push_back(result->keys.size() - 1);

			keyElem = keyElem->NextSiblingElement(LEVGEN_RESULT_KEY);
		}
		lockElem = lockElem->NextSiblingElement(LEVGEN_RESULT_LOCK);
	}
	
	// Solution path о
	TiXmlElement* solutionElem = root->FirstChildElement(LEVGEN_RESULT_SOLUTIONPATH);
	if (!solutionElem) 
		return LEVGEN_INVALIDTILESET;

	result->startx = atoi(solutionElem->Attribute(LEVGEN_RESULT_ATTR_STARTX));
	result->starty = atoi(solutionElem->Attribute(LEVGEN_RESULT_ATTR_STARTY));

	result->endx = atoi(solutionElem->Attribute(LEVGEN_RESULT_ATTR_GOALX));
	result->endy = atoi(solutionElem->Attribute(LEVGEN_RESULT_ATTR_GOALY));

	
	//Action о
	//result->locks.push_back(newlock);


	TiXmlElement* ActionElem = solutionElem->FirstChildElement(LEVGEN_RESULT_ACTION);
	
	while( ActionElem)
	{
		Action newAction;
		
		// type شϴ  ɸ
		for (int i=0; i<6; i++)
		{
			if (strcmp(ActionElem->Attribute(LEVGEN_RESULT_ATTR_TYPE), STRACTIONTYPE[i]) ==0)
			{
				newAction.type = (Action::Type) i;
				
				
				if (i == 3)	// unlock϶
				{
					TiXmlElement* UnLockElem = ActionElem->FirstChildElement(LEVGEN_RESULT_LOCK);

					CellLock newUnLockingLock;

					while (UnLockElem)
					{
						newUnLockingLock.x1 = atoi(UnLockElem->Attribute(LEVGEN_RESULT_ATTR_X));
						newUnLockingLock.x2 = atoi(UnLockElem->Attribute(LEVGEN_RESULT_ATTR_X));
						newUnLockingLock.y1 = atoi(UnLockElem->Attribute(LEVGEN_RESULT_ATTR_Y));
						newUnLockingLock.y2 = atoi(UnLockElem->Attribute(LEVGEN_RESULT_ATTR_Y));
						
						newAction.UnLockingLocks.push_back(newUnLockingLock);

						UnLockElem = UnLockElem->NextSiblingElement(LEVGEN_RESULT_LOCK);
					}

				}


				if (i == 4 ) // Solve Sokoban ϶
				{
					TiXmlElement* SolvingBlockElem = ActionElem->FirstChildElement(LEVGEN_RESULT_BLOCK);
					
					Block newSolvingBlock;

					while (SolvingBlockElem)
					{
						newSolvingBlock.x = atoi(SolvingBlockElem->Attribute(LEVGEN_RESULT_ATTR_X) );
						newSolvingBlock.y = atoi(SolvingBlockElem->Attribute(LEVGEN_RESULT_ATTR_Y) );

						newAction.SolvingBlocks.push_back(newSolvingBlock);

						SolvingBlockElem = SolvingBlockElem->NextSiblingElement(LEVGEN_RESULT_BLOCK);
					}

				}



				break;
			}
			
		}
		
		newAction.x = atoi( ActionElem->Attribute(LEVGEN_RESULT_ATTR_X) );
		newAction.y = atoi( ActionElem->Attribute(LEVGEN_RESULT_ATTR_Y) );
		newAction.exp = atoi( ActionElem->Attribute(LEVGEN_RESULT_ATTR_EXP) );

		result->m_cellSolutionPath.push_back(newAction);

		ActionElem = ActionElem->NextSiblingElement(LEVGEN_RESULT_ACTION);

	}

	//  ġ XML  о´. 
	TiXmlElement* monsterAllocElem = root->FirstChildElement(LEVGEN_RESULT_MONSTERALLOCATION);
	if (!monsterAllocElem) 
		return LEVGEN_INVALIDTILESET;

	Units unit;
	ParseMonsterXML( "unit.xml", &unit );


	TiXmlElement* MonsterElem = monsterAllocElem->FirstChildElement(LEVGEN_RESULT_MONSTER);

	while(MonsterElem)
	{
		Monster newMonster;

		
		for (int i=0; i<10; i++)
		{
			if (strcmp(MonsterElem->Attribute(LEVGEN_RESULT_ATTR_ID), unit.monsters[i].id.c_str() ) ==0)
			{
				newMonster.level = unit.monsters[i].level;
				newMonster.exp = unit.monsters[i].exp;
				break;
			}

		}

		newMonster.x = atoi( MonsterElem->Attribute(LEVGEN_RESULT_ATTR_X) );
		newMonster.y = atoi( MonsterElem->Attribute(LEVGEN_RESULT_ATTR_Y) );

		result->monsters.push_back(newMonster);

		MonsterElem = MonsterElem->NextSiblingElement(LEVGEN_RESULT_MONSTER);
	}

	// ڹ
	TiXmlElement* sokobanElem = root->FirstChildElement(LEVGEN_RESULT_SOKOBAN);
	if (!sokobanElem)
		return LEVGEN_INVALIDTILESET;

	TiXmlElement *blockElem = sokobanElem->FirstChildElement(LEVGEN_RESULT_BLOCK);

	while(blockElem)
	{
		Block newBlock;

		newBlock.x = atoi( blockElem->Attribute(LEVGEN_RESULT_ATTR_X ));
		newBlock.y = atoi( blockElem->Attribute(LEVGEN_RESULT_ATTR_Y ));
		newBlock.OnOff = 1;

		result->blocks.push_back(newBlock);

		blockElem = blockElem->NextSiblingElement(LEVGEN_RESULT_BLOCK);
	}



	return LEVGEN_NOERROR;

}

