//======================================================================
//	ǻͰк PROJECT Team <<E>>  
//	NEXON Project
//
//	R A N D O M  - L E V E L  -  G E N E R A T E R
//  ----------------------------------------------
//	MAP RENDERER
//
//=======================================================================
//	Renderer.exe      ο ֵ Ѵ. 
//	unit.xml
//	result.xml
//	\KeyLockImage
//	\PointImage
//	\TileSet
//	\UnitImage
//
//=======================================================================



#define MAINBODY

#include "stdafx.h"
#include <d3d9.h>
#include <d3dx9.h>
#include "ZCamera.h"
#include "ZFLog.h"
#include "ZWater.h"

#include "..\common\tinyxml.h"
#include "..\common\common.h"
#include "Result.h"
#include "ResultParser.h"


#define WINDOW_W		800
#define WINDOW_H		800
#define WINDOW_TITLE	"Render"




//-----------------------------------------------------------------------------
//  
//------------------------------------------------------------------------------

HWND					g_hwnd = NULL;

LPDIRECT3D9             g_pD3D       = NULL;				// D3D ̽  D3Dü
LPDIRECT3DDEVICE9       g_pd3dDevice = NULL;				//   D3D̽
LPDIRECT3DTEXTURE9		g_pTexBillboard[4] = { NULL, NULL, NULL, NULL };	//   ؽó

D3DXMATRIXA16			g_matAni;
D3DXMATRIXA16			g_matWorld;
D3DXMATRIXA16			g_matView;
D3DXMATRIXA16			g_matProj;

DWORD					g_dwMouseX = 0;				// 콺 ǥ
DWORD					g_dwMouseY = 0;				// 콺 ǥ
BOOL					g_bBillboard = TRUE;		// ó Ұΰ?
BOOL					g_bWireframe = FALSE;		// ̾ ׸ΰ?

ZCamera*				g_pCamera = NULL;			// Camera Ŭ
ZWater*					g_pWater = NULL;

ZFLog*					g_pLog = NULL;

int						map_w;
int						map_h;						// Է¹ map ο  tile 
	
int						turn = 0;					// Solution Path turn

Result					result;


LPDIRECT3DTEXTURE9		g_pTexture[20][20];				// Map Ǵ Texture



LPDIRECT3DTEXTURE9		g_pObjLockTexture[16];			// Lock Ǵ Texture
	
LPDIRECT3DTEXTURE9		g_pObjKeyTexture[16];			// Key Ǵ Texture

LPDIRECT3DTEXTURE9		g_pObjHeroTexture[4];			// ⺰ ڿ Ǵ Texture

LPDIRECT3DTEXTURE9		g_pObjPointTexture[4];			// Ʈ ڹ  ǥÿ Ǵ texture

LPDIRECT3DTEXTURE9		g_pObjMonsterTexture[10];		//  ǥÿ Ǵ texture

float hero_x;
float hero_y;
float hero_z;		//׽Ʈ ǥ

//   ǥ. Ұ XML y Ǿ, main  Z ǥ̴.

int						start_X;
int						start_Z;
int						end_X;
int						end_Z;

int						now_exp = 0;		//    ġ.




//-----------------------------------------------------------------------------
// Direct3D ʱȭ
//------------------------------------------------------------------------------

HRESULT InitD3D( HWND hWnd )
{
    // ̽ ϱ D3Dü 
    if( NULL == ( g_pD3D = Direct3DCreate9( D3D_SDK_VERSION ) ) )
        return E_FAIL;

    // ̽  ü
    //  Ʈ ׸̱⶧, ̹ Z۰ ʿϴ.
    D3DPRESENT_PARAMETERS d3dpp;
    ZeroMemory( &d3dpp, sizeof(d3dpp) );
    d3dpp.Windowed = TRUE;
    d3dpp.SwapEffect = D3DSWAPEFFECT_DISCARD;
    d3dpp.BackBufferFormat = D3DFMT_UNKNOWN;
    d3dpp.EnableAutoDepthStencil = TRUE;
    d3dpp.AutoDepthStencilFormat = D3DFMT_D16;

    /// ̽ 
    if( FAILED( g_pD3D->CreateDevice( D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, hWnd,
                                      D3DCREATE_SOFTWARE_VERTEXPROCESSING,
                                      &d3dpp, &g_pd3dDevice ) ) )
    {
        return E_FAIL;
    }

    // ⺻ø, CCW
    g_pd3dDevice->SetRenderState( D3DRS_CULLMODE, D3DCULL_CCW );

    // Z۱ Ҵ.
    g_pd3dDevice->SetRenderState( D3DRS_ZENABLE, TRUE );

    return S_OK;
}

//-----------------------------------------------------------------------------
//  
//------------------------------------------------------------------------------

void InitMatrix()
{
	///   
	D3DXMatrixIdentity( &g_matWorld );
    g_pd3dDevice->SetTransform( D3DTS_WORLD, &g_matWorld );

    //D3DXVECTOR3 vEyePt( 0.0f, 20.0f, (float)-3.0f );
    D3DXVECTOR3 vEyePt( 0.0f, 20.0f, -1.0f );
	D3DXVECTOR3 vLookatPt( 0.0f, 0.0f, 0.0f );
    D3DXVECTOR3 vUpVec( 0.0f, 1.0f, 0.0f );
	
   
	D3DXMatrixLookAtLH( &g_matView, &vEyePt, &vLookatPt, &vUpVec );
    g_pd3dDevice->SetTransform( D3DTS_VIEW, &g_matView );

    ///   
	D3DXMatrixPerspectiveFovLH( &g_matProj, D3DX_PI/4, 1.0f, 1.0f, 1000.0f );
    g_pd3dDevice->SetTransform( D3DTS_PROJECTION, &g_matProj );

	///  ø  
    D3DXMatrixPerspectiveFovLH( &g_matProj, D3DX_PI/4, 1.0f, 1.0f, 200.0f );

	/// ī޶ ʱȭ
	g_pCamera->SetView( &vEyePt, &vLookatPt, &vUpVec );

	g_pCamera->RotateLocalX(0.02f);
	
}



//--------------------------------------------
// XMLо
//---------------------------------------------

void LoadXML()
{
	ParseResult("Result.xml", &result);
	
	map_w = result.width;
	map_h = result.height;

	start_X = result.startx;
	start_Z = result.starty;

	hero_x = (float) start_X;
	hero_z = (float) start_Z;

    end_X =	result.endx;
	end_Z = result.endy;


}


//---------------------------------------------
// Texture о
//---------------------------------------------

void LoadObjTexture()
{
	InitMatrix();
	
	
	// Key Lock  ̹
	for (int i=0; i< 16; i++)
	{
		g_pObjLockTexture[i] = NULL;					
		g_pObjKeyTexture[i] = NULL;						
	}
	
	//key
	D3DXCreateTextureFromFile( g_pd3dDevice, "KeyLockImage/key1.png", &g_pObjKeyTexture[0] );			
	D3DXCreateTextureFromFile( g_pd3dDevice, "KeyLockImage/key2.png", &g_pObjKeyTexture[1] );		
	D3DXCreateTextureFromFile( g_pd3dDevice, "KeyLockImage/key3.png", &g_pObjKeyTexture[2] );		
	D3DXCreateTextureFromFile( g_pd3dDevice, "KeyLockImage/key4.png", &g_pObjKeyTexture[3] );		
	D3DXCreateTextureFromFile( g_pd3dDevice, "KeyLockImage/key5.png", &g_pObjKeyTexture[4] );		
	D3DXCreateTextureFromFile( g_pd3dDevice, "KeyLockImage/key6.png", &g_pObjKeyTexture[5] );		
	D3DXCreateTextureFromFile( g_pd3dDevice, "KeyLockImage/key7.png", &g_pObjKeyTexture[6] );		
	D3DXCreateTextureFromFile( g_pd3dDevice, "KeyLockImage/key8.png", &g_pObjKeyTexture[7] );		



	//lock
	D3DXCreateTextureFromFile( g_pd3dDevice, "KeyLockImage/lock1.png", &g_pObjLockTexture[0] );		
	D3DXCreateTextureFromFile( g_pd3dDevice, "KeyLockImage/lock2.png", &g_pObjLockTexture[1] );		
	D3DXCreateTextureFromFile( g_pd3dDevice, "KeyLockImage/lock3.png", &g_pObjLockTexture[2] );		
	D3DXCreateTextureFromFile( g_pd3dDevice, "KeyLockImage/lock4.png", &g_pObjLockTexture[3] );		
	D3DXCreateTextureFromFile( g_pd3dDevice, "KeyLockImage/lock5.png", &g_pObjLockTexture[4] );		
	D3DXCreateTextureFromFile( g_pd3dDevice, "KeyLockImage/lock6.png", &g_pObjLockTexture[5] );		
	D3DXCreateTextureFromFile( g_pd3dDevice, "KeyLockImage/lock7.png", &g_pObjLockTexture[6] );		
	D3DXCreateTextureFromFile( g_pd3dDevice, "KeyLockImage/lock8.png", &g_pObjLockTexture[7] );		
	
	//Hero					// 0 1 2 3
	D3DXCreateTextureFromFile( g_pd3dDevice, "UnitImage/hero_n.png", &g_pObjHeroTexture[0] );
	D3DXCreateTextureFromFile( g_pd3dDevice, "UnitImage/hero_w.png", &g_pObjHeroTexture[1] );
	D3DXCreateTextureFromFile( g_pd3dDevice, "UnitImage/hero_e.png", &g_pObjHeroTexture[2] );
	D3DXCreateTextureFromFile( g_pd3dDevice, "UnitImage/hero_s.png", &g_pObjHeroTexture[3] );
	
	//Point
	D3DXCreateTextureFromFile( g_pd3dDevice, "PointImage/start.png", &g_pObjPointTexture[0] );		//start
	D3DXCreateTextureFromFile( g_pd3dDevice, "PointImage/end.png",   &g_pObjPointTexture[1]	);		//end
	D3DXCreateTextureFromFile( g_pd3dDevice, "PointImage/stone.png", &g_pObjPointTexture[2] );		//Rock


	//Monster
	D3DXCreateTextureFromFile( g_pd3dDevice, "UnitImage/mon1.png", &g_pObjMonsterTexture[0] );
	D3DXCreateTextureFromFile( g_pd3dDevice, "UnitImage/mon2.png", &g_pObjMonsterTexture[1] );
	D3DXCreateTextureFromFile( g_pd3dDevice, "UnitImage/mon3.png", &g_pObjMonsterTexture[2] );
	D3DXCreateTextureFromFile( g_pd3dDevice, "UnitImage/mon4.png", &g_pObjMonsterTexture[3] );
	D3DXCreateTextureFromFile( g_pd3dDevice, "UnitImage/mon5.png", &g_pObjMonsterTexture[4] );
	D3DXCreateTextureFromFile( g_pd3dDevice, "UnitImage/mon6.png", &g_pObjMonsterTexture[5] );
	D3DXCreateTextureFromFile( g_pd3dDevice, "UnitImage/mon7.png", &g_pObjMonsterTexture[6] );
	D3DXCreateTextureFromFile( g_pd3dDevice, "UnitImage/mon8.png", &g_pObjMonsterTexture[7] );
	D3DXCreateTextureFromFile( g_pd3dDevice, "UnitImage/mon9.png", &g_pObjMonsterTexture[8] );
	D3DXCreateTextureFromFile( g_pd3dDevice, "UnitImage/mon10.png", &g_pObjMonsterTexture[9] );

}

string AddPathName(string id)
{
	string tmp;
	string a="TileSet/";
	string b=".jpg";
		
	tmp = a+id;
	tmp +=b;
	return tmp;

}

void LoadTexture()
{	
	InitMatrix();
	LoadXML();


	//a.c_str();  // C String

	for (int j=0; j<map_h; j++)
	{
		for (int i = 0; i<map_w; i++)
		{
			g_pTexture[j][i] = NULL; 
		}
	}

	
	for (int i=0; i<map_h; i++)
	{
		for (int j=0; j<map_w; j++)
		{
			D3DXCreateTextureFromFile( g_pd3dDevice, (LPCSTR)(AddPathName(result.idmatrix[i][j]).c_str()) , &g_pTexture[i][j] );
		}
	}

}







//-----------------------------------------------------------------------------
//  ʱȭ
//------------------------------------------------------------------------------

HRESULT InitGeometry()
{
	LoadObjTexture();	
	LoadTexture();

	//  콺 ġ 
	POINT	pt;
	GetCursorPos( &pt );
	g_dwMouseX = pt.x;
	g_dwMouseY = pt.y;
	return S_OK;
}

HRESULT InitObjects()
{
	g_pLog = new ZFLog( ZF_LOG_TARGET_WINDOW );
	g_pCamera = new ZCamera;
	g_pWater = new ZWater;
	g_pWater->Create( g_pd3dDevice, 100, 100, 100 );

	return S_OK;
}

void DeleteObjects()
{
	/// ϵ Ŭ Ұ
	S_DEL( g_pWater );
	S_DEL( g_pLog );
	S_DEL( g_pCamera );
}

//-----------------------------------------------------------------------------
// ʱȭ ü Ұ
//------------------------------------------------------------------------------

VOID Cleanup()
{
	for( int i = 0 ; i < 4 ; i++ ) S_REL( g_pTexBillboard[i] );
	S_REL( g_pd3dDevice );
	S_REL( g_pD3D );
}


//-----------------------------------------------------------------------------
//  
//------------------------------------------------------------------------------

VOID SetupLights()
{
    /// (material)
    ///  ̽  ϳ   ִ.
    D3DMATERIAL9 mtrl;
    ZeroMemory( &mtrl, sizeof(D3DMATERIAL9) );
    mtrl.Diffuse.r = mtrl.Ambient.r = 1.0f;
    mtrl.Diffuse.g = mtrl.Ambient.g = 1.0f;
    mtrl.Diffuse.b = mtrl.Ambient.b = 1.0f;
    mtrl.Diffuse.a = mtrl.Ambient.a = 1.0f;
    g_pd3dDevice->SetMaterial( &mtrl );

    g_pd3dDevice->SetRenderState( D3DRS_LIGHTING, FALSE );			///  Ҵ

    g_pd3dDevice->SetRenderState( D3DRS_AMBIENT, 0xffffffff );		/// ȯ汤(ambient light)  
}

//-----------------------------------------------------------------------------
// Status 
//------------------------------------------------------------------------------
 //
void LogStatus( void )
{
	g_pLog->Log( "Wireframe:%d", g_bWireframe );
	g_pLog->Log( "BillBoard:%d", g_bBillboard );
}



//------------------------------------------------------------------------------
// ش Slot ǥ Tile ׸. 
//------------------------------------------------------------------------------

void DrawTile(float x, float y, float z)
{
	g_pd3dDevice->SetRenderState( D3DRS_SRCBLEND,  D3DBLEND_SRCALPHA );
	g_pd3dDevice->SetRenderState( D3DRS_DESTBLEND, D3DBLEND_INVSRCALPHA );
	//g_pd3dDevice->SetRenderState( D3DRS_ALPHATESTENABLE, TRUE );
	g_pd3dDevice->SetRenderState( D3DRS_ALPHAREF,        0x08 );
	g_pd3dDevice->SetRenderState( D3DRS_ALPHAFUNC, D3DCMP_GREATEREQUAL );

	struct MYVERTEX
	{
		enum { FVF = D3DFVF_XYZ | D3DFVF_TEX1 };
		float px, py, pz;
		float tu, tv;
	};
	
	MYVERTEX tileVtx[4] = 
	{ 


		{ -2.5f,  0, 0,     0, 1 },
		{ -2.5f,  0, 4.0f,  0, 0 },
		{  2.5f,  0, 0,     1, 1 },
		{  2.5f,  0, 4.0f,  1, 0 }

		
	};	

	D3DXMATRIXA16	tileBoard;
	
	D3DXMatrixIdentity( &tileBoard );

	// 0 ؽó  ؽó ø
	g_pd3dDevice->SetTexture( 1, NULL );
	g_pd3dDevice->SetFVF( MYVERTEX::FVF );


	tileBoard._41 = -20 +5*x;	
	tileBoard._42 = 0;
	tileBoard._43 = 10 -4 *z;
				
	g_pd3dDevice->SetTexture( 0, g_pTexture[(int)z][(int)x]);
	g_pd3dDevice->SetTransform( D3DTS_WORLD, &tileBoard );
	g_pd3dDevice->DrawPrimitiveUP( D3DPT_TRIANGLESTRIP, 2, tileVtx, sizeof(MYVERTEX) );

	g_pd3dDevice->SetRenderState( D3DRS_ALPHATESTENABLE, FALSE );
	g_pd3dDevice->SetTransform( D3DTS_WORLD, &tileBoard );

}



// ش Cell ǥ Key ׸. 
void DrawKey(float x, float y, float z,  int keyType)
{
	g_pd3dDevice->SetRenderState( D3DRS_ALPHABLENDENABLE,   TRUE );

	g_pd3dDevice->SetRenderState( D3DRS_SRCBLEND,  D3DBLEND_SRCALPHA );
	g_pd3dDevice->SetRenderState( D3DRS_DESTBLEND, D3DBLEND_INVSRCALPHA );
	
	g_pd3dDevice->SetRenderState( D3DRS_ALPHATESTENABLE, TRUE );
	
	g_pd3dDevice->SetRenderState( D3DRS_ALPHAREF,        0x08 );
	g_pd3dDevice->SetRenderState( D3DRS_ALPHAFUNC, D3DCMP_GREATEREQUAL );

	struct MYVERTEX
	{
		enum { FVF = D3DFVF_XYZ | D3DFVF_TEX1 };
		float px, py, pz;
		float tu, tv;
	};
	
	MYVERTEX objVtx[4] = 
	{ 


		{ -0.5f,  0,	0,		0, 1 },
		{ -0.5f,  0,	0.8f,	0, 0 },
		{  0.5f,  0,	0,		1, 1 },
		{  0.5f,  0,	0.8f,	1, 0 }
			
	};
	
	D3DXMATRIXA16	objBoard;
	
	D3DXMatrixIdentity( &objBoard );

	// 0 ؽó  ؽó ø
	g_pd3dDevice->SetTexture( 1, NULL );
	g_pd3dDevice->SetFVF( MYVERTEX::FVF );

	
	objBoard._41 = x - 22.0f;	
	objBoard._42 = y + 0.02f;
	objBoard._43 = -0.8f* z + 13.2f;
				
	g_pd3dDevice->SetTexture( 0, g_pObjKeyTexture[keyType]);

	g_pd3dDevice->SetTransform( D3DTS_WORLD, &objBoard );
	g_pd3dDevice->DrawPrimitiveUP( D3DPT_TRIANGLESTRIP, 2, objVtx, sizeof(MYVERTEX) );


	g_pd3dDevice->SetRenderState( D3DRS_ALPHATESTENABLE, FALSE );
	g_pd3dDevice->SetTransform( D3DTS_WORLD, &g_matWorld );


}

// ش Cell ǥ   ´ Lock ׸. 
void DrawLock(float x, float y, float z ,  int dir, int lockType)		// 0  1  2  3  
{
	g_pd3dDevice->SetRenderState( D3DRS_SRCBLEND,  D3DBLEND_SRCALPHA );
	g_pd3dDevice->SetRenderState( D3DRS_DESTBLEND, D3DBLEND_INVSRCALPHA );
	g_pd3dDevice->SetRenderState( D3DRS_ALPHATESTENABLE, TRUE );
	g_pd3dDevice->SetRenderState( D3DRS_ALPHAREF,        0x08 );
	g_pd3dDevice->SetRenderState( D3DRS_ALPHAFUNC, D3DCMP_GREATEREQUAL );

	struct MYVERTEX
	{
		enum { FVF = D3DFVF_XYZ | D3DFVF_TEX1 };
		float px, py, pz;
		float tu, tv;
	};

	//4			// ٴ ǥ ׳ ٸ.   if  ȿ ̵Ұ̴. 
	MYVERTEX objVtxTest[4] = 
	{ 


		{ -0.5f,  0,	0,		0, 1 },
		{ -0.5f,  0,	0.8f,	0, 0 },
		{  0.5f,  0,	0,		1, 1 },
		{  0.5f,  0,	0.8f,	1, 0 }
			
	};

	//3 
	MYVERTEX objVtxSouth[4] = 
	{ 
		{ -0.5f,  0,	0,	0, 1 },
		{ -0.5f,  0.8f, 0,	0, 0 },
		{  0.5f,  0,	0,	1, 1 },
		{  0.5f,  0.8f,	0,	1, 0 }
	};

	//2  
	MYVERTEX objVtxEast[4] =
	{
		{ 0,  0,	-0.4f,	0, 1 },
		{ 0,  0.8f, -0.4f,	0, 0 },
		{ 0,  0,	0.4f,	1, 1 },
		{ 0,  0.8f,	0.4f,	1, 0 }
	

	};

	//1 		
	MYVERTEX objVtxWest[4] =
	{
		{ 0,  0,	-0.4f,	0, 1 },
		{ 0,  0.8f, -0.4f,	0, 0 },
		{ 0,  0,	0.4f,	1, 1 },
		{ 0,  0.8f,	0.4f,	1, 0 }
	

	};

	//0 
	MYVERTEX objVtxNorth[4] = 
	{ 


		{ -0.5f,  0,	0,	0, 1 },
		{ -0.5f,  0.8f, 0,	0, 0 },
		{  0.5f,  0,	0,	1, 1 },
		{  0.5f,  0.8f,	0,	1, 0 }
			
	};


	D3DXMATRIXA16	objBoard;
	
	D3DXMatrixIdentity( &objBoard );

	// 0 ؽó  ؽó ø
	g_pd3dDevice->SetTexture( 1, NULL );
	g_pd3dDevice->SetFVF( MYVERTEX::FVF );

	
	objBoard._41 = x - 22.0f;	
	objBoard._42 = y + 0.02f;
	objBoard._43 = -0.8f* z + 13.2f;
				
	g_pd3dDevice->SetTexture( 0, g_pObjLockTexture[lockType]);
	
	//g_pd3dDevice->SetTransform( D3DTS_WORLD, &objBoard );
	
	
	// Lock 
	if (dir ==3)							
	{
		objBoard._43 += -0.4f;

		g_pd3dDevice->SetTransform( D3DTS_WORLD, &objBoard );
		g_pd3dDevice->DrawPrimitiveUP( D3DPT_TRIANGLESTRIP, 2, objVtxTest, sizeof(MYVERTEX) );
	}
	else if (dir ==2)						// 
	{
		objBoard._41 += 0.5f;
		g_pd3dDevice->SetTransform( D3DTS_WORLD, &objBoard );
		
		g_pd3dDevice->DrawPrimitiveUP( D3DPT_TRIANGLESTRIP, 2, objVtxTest, sizeof(MYVERTEX) );
	}
	else if (dir ==1)						// 
	{
		objBoard._41 += -0.5f;
		g_pd3dDevice->SetTransform( D3DTS_WORLD, &objBoard );
		
		g_pd3dDevice->DrawPrimitiveUP( D3DPT_TRIANGLESTRIP, 2, objVtxTest, sizeof(MYVERTEX) );
	}
	else if (dir ==0)						// 
	{
		
		objBoard._43 += 0.4f; 
		g_pd3dDevice->SetTransform( D3DTS_WORLD, &objBoard );
		
		g_pd3dDevice->DrawPrimitiveUP( D3DPT_TRIANGLESTRIP, 2, objVtxTest, sizeof(MYVERTEX) );

	}
	

			
	g_pd3dDevice->SetRenderState( D3DRS_ALPHATESTENABLE, FALSE );
	g_pd3dDevice->SetTransform( D3DTS_WORLD, &g_matWorld );

}

//-----------------------------------------------------------------
// Start End Point ׸
//-----------------------------------------------------------------
void DrawPoint( float x, float y, float z ,  int BlockType )			// 0 Start 1 End
{
	g_pd3dDevice->SetRenderState( D3DRS_SRCBLEND,  D3DBLEND_SRCALPHA );
	g_pd3dDevice->SetRenderState( D3DRS_DESTBLEND, D3DBLEND_INVSRCALPHA );
	g_pd3dDevice->SetRenderState( D3DRS_ALPHATESTENABLE, TRUE );
	g_pd3dDevice->SetRenderState( D3DRS_ALPHAREF,        0x08 );
	g_pd3dDevice->SetRenderState( D3DRS_ALPHAFUNC, D3DCMP_GREATEREQUAL );

	struct MYVERTEX
	{
		enum { FVF = D3DFVF_XYZ | D3DFVF_TEX1 };
		float px, py, pz;
		float tu, tv;
	};
	
	MYVERTEX objVtx[4] = 
	{ 


		{ -0.5f,  0,	0,		0, 1 },
		{ -0.5f,  0,	0.8f,	0, 0 },
		{  0.5f,  0,	0,		1, 1 },
		{  0.5f,  0,	0.8f,	1, 0 }
			
	};

	
	D3DXMATRIXA16	objBoard;
	D3DXMatrixIdentity( &objBoard );

	// 0 ؽó  ؽó ø
	g_pd3dDevice->SetTexture( 1, NULL );
	g_pd3dDevice->SetFVF( MYVERTEX::FVF );

	
	objBoard._41 = x - 22.0f;	
	objBoard._42 = y + 0.02f;
	objBoard._43 = -0.8f* z + 13.2f;
				
	g_pd3dDevice->SetTexture( 0, g_pObjPointTexture[BlockType]);

	g_pd3dDevice->SetTransform( D3DTS_WORLD, &objBoard );
	g_pd3dDevice->DrawPrimitiveUP( D3DPT_TRIANGLESTRIP, 2, objVtx, sizeof(MYVERTEX) );


	g_pd3dDevice->SetRenderState( D3DRS_ALPHATESTENABLE, FALSE );
	g_pd3dDevice->SetTransform( D3DTS_WORLD, &g_matWorld );

}

void DrawSokobanBlock( float x, float y, float z )
{
	g_pd3dDevice->SetRenderState( D3DRS_SRCBLEND,  D3DBLEND_SRCALPHA );
	g_pd3dDevice->SetRenderState( D3DRS_DESTBLEND, D3DBLEND_INVSRCALPHA );
	g_pd3dDevice->SetRenderState( D3DRS_ALPHATESTENABLE, TRUE );
	g_pd3dDevice->SetRenderState( D3DRS_ALPHAREF,        0x08 );
	g_pd3dDevice->SetRenderState( D3DRS_ALPHAFUNC, D3DCMP_GREATEREQUAL );

	struct MYVERTEX
	{
		enum { FVF = D3DFVF_XYZ | D3DFVF_TEX1 };
		float px, py, pz;
		float tu, tv;
	};
	
	MYVERTEX objVtx[4] = 
	{ 


		{ -0.5f,  0,	0,		0, 1 },
		{ -0.5f,  0,	0.8f,	0, 0 },
		{  0.5f,  0,	0,		1, 1 },
		{  0.5f,  0,	0.8f,	1, 0 }
			
	};

	
	D3DXMATRIXA16	objBoard;
	D3DXMatrixIdentity( &objBoard );

	// 0 ؽó  ؽó ø
	g_pd3dDevice->SetTexture( 1, NULL );
	g_pd3dDevice->SetFVF( MYVERTEX::FVF );

	
	objBoard._41 = x - 22.0f;	
	objBoard._42 = y + 0.02f;
	objBoard._43 = -0.8f* z + 13.2f;
				
	g_pd3dDevice->SetTexture( 0, g_pObjPointTexture[2]);

	g_pd3dDevice->SetTransform( D3DTS_WORLD, &objBoard );
	g_pd3dDevice->DrawPrimitiveUP( D3DPT_TRIANGLESTRIP, 2, objVtx, sizeof(MYVERTEX) );


	g_pd3dDevice->SetRenderState( D3DRS_ALPHATESTENABLE, FALSE );
	g_pd3dDevice->SetTransform( D3DTS_WORLD, &g_matWorld );

}


//----------------------------------------------------------------------------
//  ׸
//----------------------------------------------------------------------------

void DrawMonster( float x, float y, float z ,  int monNumber )			
{
	g_pd3dDevice->SetRenderState( D3DRS_SRCBLEND,  D3DBLEND_SRCALPHA );
	g_pd3dDevice->SetRenderState( D3DRS_DESTBLEND, D3DBLEND_INVSRCALPHA );
	g_pd3dDevice->SetRenderState( D3DRS_ALPHATESTENABLE, TRUE );
	g_pd3dDevice->SetRenderState( D3DRS_ALPHAREF,        0x08 );
	g_pd3dDevice->SetRenderState( D3DRS_ALPHAFUNC, D3DCMP_GREATEREQUAL );

	struct MYVERTEX
	{
		enum { FVF = D3DFVF_XYZ | D3DFVF_TEX1 };
		float px, py, pz;
		float tu, tv;
	};
	
	MYVERTEX objVtx[4] = 
	{ 


		{ -0.5f,  0,	0,		0, 1 },
		{ -0.5f,  0,	0.8f,	0, 0 },
		{  0.5f,  0,	0,		1, 1 },
		{  0.5f,  0,	0.8f,	1, 0 }
			
	};

	
	D3DXMATRIXA16	objBoard;
	D3DXMatrixIdentity( &objBoard );

	// 0 ؽó  ؽó ø
	g_pd3dDevice->SetTexture( 1, NULL );
	g_pd3dDevice->SetFVF( MYVERTEX::FVF );

	
	objBoard._41 = x - 22.0f;	
	objBoard._42 = y + 0.02f;
	objBoard._43 = -0.8f* z + 13.2f;

	g_pd3dDevice->SetTexture( 0, g_pObjMonsterTexture[monNumber]);

	g_pd3dDevice->SetTransform( D3DTS_WORLD, &objBoard );
	g_pd3dDevice->DrawPrimitiveUP( D3DPT_TRIANGLESTRIP, 2, objVtx, sizeof(MYVERTEX) );


	g_pd3dDevice->SetRenderState( D3DRS_ALPHATESTENABLE, FALSE );
	g_pd3dDevice->SetTransform( D3DTS_WORLD, &g_matWorld );

}


//-----------------------------------------------------------------------------
//   ׸
//------------------------------------------------------------------------------

void DrawMap()
{
	
	for (int z = 0; z<map_h; z++)
	{
		for (int x = 0; x < map_w; x++)
		{
			DrawTile( (float)x, 0.0f, (float)z );		
		}
	}

	DrawPoint( (float) start_X, 0.0f, (float) start_Z, 0);
	DrawPoint( (float) end_X, 0.0f, (float) end_Z, 1);

	//DrawPoint ( 7, 0, 9, 2);
}

//-------------------------------------------------------------------
// ׸
//--------------------------------------------------------------------

void DrawHero( float x, float y, float z ,  int dir )
{
	g_pd3dDevice->SetRenderState( D3DRS_SRCBLEND,  D3DBLEND_SRCALPHA );
	g_pd3dDevice->SetRenderState( D3DRS_DESTBLEND, D3DBLEND_INVSRCALPHA );
	g_pd3dDevice->SetRenderState( D3DRS_ALPHATESTENABLE, TRUE );
	g_pd3dDevice->SetRenderState( D3DRS_ALPHAREF,        0x08 );
	g_pd3dDevice->SetRenderState( D3DRS_ALPHAFUNC, D3DCMP_GREATEREQUAL );

	struct MYVERTEX
	{
		enum { FVF = D3DFVF_XYZ | D3DFVF_TEX1 };
		float px, py, pz;
		float tu, tv;
	};
	
	MYVERTEX objVtx[4] = 
	{ 


		{ -0.5f,  0,	0,		0, 1 },
		{ -0.5f,  0,	0.8f,	0, 0 },
		{  0.5f,  0,	0,		1, 1 },
		{  0.5f,  0,	0.8f,	1, 0 }
			
	};

	
	D3DXMATRIXA16	objBoard;
	D3DXMatrixIdentity( &objBoard );

	// 0 ؽó  ؽó ø
	g_pd3dDevice->SetTexture( 1, NULL );
	g_pd3dDevice->SetFVF( MYVERTEX::FVF );

	
	objBoard._41 = x - 22.0f;	
	objBoard._42 = y + 0.02f;
	objBoard._43 = -0.8f* z + 13.2f;
				
	g_pd3dDevice->SetTexture( 0, g_pObjHeroTexture[dir]);

	g_pd3dDevice->SetTransform( D3DTS_WORLD, &objBoard );
	g_pd3dDevice->DrawPrimitiveUP( D3DPT_TRIANGLESTRIP, 2, objVtx, sizeof(MYVERTEX) );


	g_pd3dDevice->SetRenderState( D3DRS_ALPHATESTENABLE, FALSE );
	g_pd3dDevice->SetTransform( D3DTS_WORLD, &g_matWorld );

}




//-----------------------------------------------------------------------------
// Ű Է ó
//------------------------------------------------------------------------------
 
void ProcessKey( void )
{
	
	if( GetAsyncKeyState( 'Q' ) ) g_pCamera->MoveLocalZ( 0.5f  );	// ī޶ !
	if( GetAsyncKeyState( 'Z' ) ) g_pCamera->MoveLocalZ( -0.5f );	// ī޶ !
	
	if( GetAsyncKeyState( 'A' ) ) g_pCamera->MoveLocalX( -0.5f );	// ī޶ · ̵
	if( GetAsyncKeyState( 'D' ) ) g_pCamera->MoveLocalX( 0.5f  );	// ī޶  ̵
	if( GetAsyncKeyState( 'W' ) ) g_pCamera->MoveLocalY_ex( 0.5f  );	// ī޶  ̵
	if( GetAsyncKeyState( 'S' ) ) g_pCamera->MoveLocalY_ex( -0.5f );	// ī޶ Ϸ ̵
	
	//ȸ 
	if( GetAsyncKeyState( 'F' ) ) g_pCamera->RotateLocalY( 0.05f );
	if( GetAsyncKeyState( 'C' ) ) g_pCamera->RotateLocalX( 0.001f );

	//  ġƮŰ
	if( GetAsyncKeyState( 'L' ) ) hero_x += 0.25f;						
	if( GetAsyncKeyState( 'J' ) ) hero_x += -0.25f;
	if( GetAsyncKeyState( 'I' ) ) hero_z += -0.2f;
	if( GetAsyncKeyState( 'K' ) ) hero_z += 0.2f;

		
}



void PrintMonster()
{
	int how_many = result.monsters.size();
	


	if ( result.m_cellSolutionPath[turn].type == (Action::Type) 5 )  // ൿ Kill Monster϶
	{
		for (int i=0; i<(int) (result.monsters.size()); i++)
		{
			if( result.monsters[i].x == result.m_cellSolutionPath[turn].x &&
				result.monsters[i].y == result.m_cellSolutionPath[turn].y)
			{
				result.monsters[i].x +=10000;
			}
		}
	}
	
	for (int i=0; i<how_many; i++)
	{
		DrawMonster( (float) (result.monsters[i].x), 0.1f, (float)(result.monsters[i].y), result.monsters[i].level-1);
	}


	if( GetAsyncKeyState( 'B' ) )
	{
		for (int i=0; i<(int)(result.monsters.size()); i++)
		{
			result.monsters[i].x += 10000;
		}
	}

}

void PrintSokobanBlock()
{
	int tempX = result.blocks[0].x;
	int tempY = result.blocks[0].y;
//	DrawSokobanBlock (result.blocks[0].x, 0.1f, result.blocks[0].y);
	
	for (int i=0; i<(int) (result.blocks.size()); i++)
	{
		DrawSokobanBlock ( (float) (result.blocks[i].x), 0.1f, (float)(result.blocks[i].y));
	}
	
	if ( result.m_cellSolutionPath[turn].type == (Action::Type) 4)		// Action Solve Sokoban ϶
	{
		//  Map  Block鿡 Ͽ
		for(int i=0; i<(int)(result.blocks.size()); i++)
		{
			// Turn Solve Sokoban Action   SolvingBlocks  Block  ̸ŭ
			for (int j=0; j< (int) (result.m_cellSolutionPath[turn].SolvingBlocks.size()); j++)
			{
				//Map  Block ǥ, ִ Block  j °  ǥ ٸ.
				if ( result.m_cellSolutionPath[turn].SolvingBlocks[j].x ==  result.blocks[i].x &&
					result.m_cellSolutionPath[turn].SolvingBlocks[j].y ==  result.blocks[i].y  )
				{
					result.blocks[i].OnOff = 0;
					result.blocks[i].x += 10000;

				}

			}


		}
	}

}

void PrintLock()
{
	
	for (int i= 0; i<(int)(result.locks.size()); i++)
	{
		if (result.locks[i].x1 != -1000 && result.locks[i].y1 != -1000)
		{
			
			for (int x = result.locks[i].x1; x <= result.locks[i].x2; x++)
			{
				for (int y = result.locks[i].y1; y <= result.locks[i].y2; y++)
				{
					DrawLock((float) x, 0.0f, (float) y, result.locks[i].dir, i);			// -22.0f , 0.2f, 13.2f  
				}
			}
		}
	}

	if ( result.m_cellSolutionPath[turn].type == (Action::Type) 3 )  // ൿ Unlock϶
	{
		//  Map  Lock ؼ
		for (int i=0; i<(int)(result.locks.size()); i++)					
		{
			//  Unlock Action  UnLockingLock[] 
			for (int j=0; j<(int)(result.m_cellSolutionPath[turn].UnLockingLocks.size()); j++)	
			{
				//UnLockingLock[j] ǥ Map Lock Ű  ȿ 

				if( result.m_cellSolutionPath[turn].UnLockingLocks[j].x1 >= result.locks[i].x1  &&
					result.m_cellSolutionPath[turn].UnLockingLocks[j].x1 <= result.locks[i].x2  &&
					
					result.m_cellSolutionPath[turn].UnLockingLocks[j].y1 >= result.locks[i].y1  &&
					result.m_cellSolutionPath[turn].UnLockingLocks[j].y1 <= result.locks[i].y2     )
				{
					result.locks[i].x1 += 10000;	// ȵθ޴ٷ . 
				}

			}
		}
	}

}


//  ̵.
void HeroMove ()
{
				// 0123 ϼ
	int dx, dy;

	if( turn >0 )
	{
		dx = result.m_cellSolutionPath[turn].x - result.m_cellSolutionPath[turn -1].x;
		dy = result.m_cellSolutionPath[turn].y - result.m_cellSolutionPath[turn -1].y;
	}
	else dx = dy =0;

	int dir=3;

	if ( dx == -1 && dy ==0 ) dir =2;
	else if (dx == 1 && dy ==0 ) dir =1;
	else if (dx ==0 && dy == -1 ) dir =0;
	else if (dx ==0 && dy == 1) dir =3;
	

		

	

	
	
	if( GetAsyncKeyState( 'N' ) ) 
	{	
		if ( hero_x != end_X || hero_z != end_Z )
		{
			hero_x = (float) (result.m_cellSolutionPath[turn].x);
			hero_z = (float) (result.m_cellSolutionPath[turn].y);
			turn++;
			now_exp = result.m_cellSolutionPath[turn].exp;
			//g_pLog->Log( "Yong-Ja move to ( %d, $d ) \n", hero_x, hero_z );
		}
	}
	if( GetAsyncKeyState( 'M' ) )
	{
		if(turn > 0)
		{
			turn--;
			hero_x = (float) (result.m_cellSolutionPath[turn].x);
			hero_z = (float) (result.m_cellSolutionPath[turn].y);
		}
			//g_pLog->Log( "Yong-Ja move to ( %d, $d ) \n", hero_x, hero_z );
	}
	DrawHero( hero_x, hero_y, hero_z, dir);




//	g_pLog->Log( "Yong-Ja move to ( %d, $d ) \n", hero_x, hero_z );


}


void PrintKey()
{
	if ( result.m_cellSolutionPath[turn].type == (Action::Type) 2 )  // ൿ GetKey϶
	{
		for (int i=0; i<(int) (result.keys.size()); i++)
		{
			if(result.keys[i].x == result.m_cellSolutionPath[turn].x &&
				result.keys[i].y == result.m_cellSolutionPath[turn].y)
			{
				result.keys[i].x += 10000;
			}
		}
	}

	for (int i= 0; i<(int) (result.keys.size()); i++)
	{
		DrawKey((float) (result.keys[i].x), 0.1f, (float) (result.keys[i].y), result.keys[i].relLockIndex);			// -22.0f , 0.2f, 13.2f  
	}


}




/**-----------------------------------------------------------------------------
 * Է ó
 *------------------------------------------------------------------------------
 */
void ProcessInputs( void )
{
	D3DXMATRIXA16*	pmatView = g_pCamera->GetViewMatrix();		// ī޶  ´.
	g_pd3dDevice->SetTransform( D3DTS_VIEW, pmatView );			// ī޶  
	ProcessKey();

	
}



//-----------------------------------------------------------------------------
// ִϸ̼ 
//------------------------------------------------------------------------------

VOID Animate()
{
	D3DXMatrixIdentity( &g_matAni );

	SetupLights();
	ProcessInputs();

	DrawMap();
	HeroMove();

	PrintMonster();
	PrintLock();
	PrintKey();
	PrintSokobanBlock();
}

VOID Render()
{
    /// ĸۿ Z ʱȭ
    g_pd3dDevice->Clear( 0, NULL, D3DCLEAR_TARGET|D3DCLEAR_ZBUFFER, D3DCOLOR_XRGB(200,200,200), 1.0f, 0 );
	g_pd3dDevice->SetRenderState( D3DRS_FILLMODE, g_bWireframe ? D3DFILL_WIREFRAME : D3DFILL_SOLID );

	    
		
	///  
    if( SUCCEEDED( g_pd3dDevice->BeginScene() ) )
    {
			
		//Animate() ȿ ǥ  ׸   . 
		Animate();
		
		

		
		g_pd3dDevice->EndScene();
    }

    /// ĸ۸ ̴ ȭ!
    g_pd3dDevice->Present( NULL, NULL, NULL, NULL );
}




/**-----------------------------------------------------------------------------
 *  ν
 *------------------------------------------------------------------------------
 */
LRESULT WINAPI MsgProc( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam )
{
    switch( msg )
    {
        case WM_DESTROY :
            Cleanup();
            PostQuitMessage( 0 );
            return 0;
		case WM_KEYDOWN : 
			switch( wParam )
			{
				case VK_ESCAPE :
					PostMessage( hWnd, WM_DESTROY, 0, 0L );
					break;
				case '1' :
					g_bWireframe = !g_bWireframe;
					break;
				case '2' :
					g_bBillboard = !g_bBillboard;
					break;
			}
			break;
    }

    return DefWindowProc( hWnd, msg, wParam, lParam );
}




/**-----------------------------------------------------------------------------
 * α׷ 
 *------------------------------------------------------------------------------
 */
INT WINAPI WinMain( HINSTANCE hInst, HINSTANCE, LPSTR, INT )
{
    ///  Ŭ 
    WNDCLASSEX wc = { sizeof(WNDCLASSEX), CS_CLASSDC, MsgProc, 0L, 0L,
                      GetModuleHandle(NULL), NULL, NULL, NULL, NULL,
                      "Renderer", NULL };
    RegisterClassEx( &wc );

    ///  
    HWND hWnd = CreateWindow( "Renderer", WINDOW_TITLE,
                              WS_OVERLAPPEDWINDOW, 100, 100, WINDOW_W, WINDOW_H,
                              GetDesktopWindow(), NULL, wc.hInstance, NULL );

	g_hwnd = hWnd;

	srand( GetTickCount() );

    /// Direct3D ʱȭ
    if( SUCCEEDED( InitD3D( hWnd ) ) )
    {
		if( SUCCEEDED( InitObjects() ) )
		{
			if( SUCCEEDED( InitGeometry() ) )
			{

        		///  
				ShowWindow( hWnd, SW_SHOWDEFAULT );
				UpdateWindow( hWnd );

        		/// ޽ 
				MSG msg;
				ZeroMemory( &msg, sizeof(msg) );
				while( msg.message!=WM_QUIT )
				{
            		/// ޽ť ޽  ޽ ó
					if( PeekMessage( &msg, NULL, 0U, 0U, PM_REMOVE ) )
					{
						TranslateMessage( &msg );
						DispatchMessage( &msg );
					}
					else
					/// ó ޽  Render()Լ ȣ
						Render();
				}
			}
		}
    }

	DeleteObjects();
    UnregisterClass( "Renderer", wc.hInstance );
    return 0;
}
